# PConfigArgs Class Reference

This class parse command line arguments with the ability to override them from a PConfig file/registry. More...

`#include <args.h>`

Inheritance diagram for PConfigArgs:

List of all members.

## Public Member Functions

Construction
| PConfigArgs (const PArgList &args)
Overrides from class PArgList
virtual PINDEX | GetOptionCount (char optionChar) const
| Get the count of the number of times the option was specified on the command line.
virtual PINDEX | GetOptionCount (const char *optionStr) const
| Get the count of option.
virtual PINDEX | GetOptionCount (const PString &optionName) const
| Get the count of option.
virtual PString | GetOptionString (char optionChar, const char *dflt=NULL) const
| Get option string.
virtual PString | GetOptionString (const char *optionStr, const char *dflt=NULL) const
| Get option string.
virtual PString | GetOptionString (const PString &optionName, const char *dflt=NULL) const
| Get option string.
Overrides from class PArgList
void | Save (const PString &optionName)
| Save the current options to the PConfig.
void | SetSectionName (const PString &section)
| Set the PConfig section name for options.
const PString & | GetSectionName () const
| Get the PConfig section name for options.
void | SetNegationPrefix (const PString &prefix)
| Set the prefix for option negation.
const PString & | GetNegationPrefix () const
| Get the prefix for option negation.

## Protected Member Functions

PString | CharToString (char ch) const

## Protected Attributes

PConfig | config
PString | sectionName
PString | negationPrefix

## Detailed Description

This class parse command line arguments with the ability to override them from a PConfig file/registry.

## Constructor & Destructor Documentation

PConfigArgs::PConfigArgs | ( | const PArgList & | args | ) |

Parameters:

  args | Raw argument list.

## Member Function Documentation

PString PConfigArgs::CharToString | ( | char | ch | ) | const`[protected]`

const PString& PConfigArgs::GetNegationPrefix | ( |  | ) | const`[inline]`

Get the prefix for option negation.

The default is "no-".

virtual PINDEX PConfigArgs::GetOptionCount | ( | const PString & | optionName | ) | const`[virtual]`

Get the count of option.

Parameters:

  optionName | String code for the option

Reimplemented from PArgList.

virtual PINDEX PConfigArgs::GetOptionCount | ( | const char * | optionStr | ) | const`[virtual]`

Get the count of option.

Parameters:

  optionStr | String code for the option

Reimplemented from PArgList.

virtual PINDEX PConfigArgs::GetOptionCount | ( | char | optionChar | ) | const`[virtual]`

Get the count of the number of times the option was specified on the command line.

Returns:
  option repeat count.

Parameters:

  optionChar | Character letter code for the option

Reimplemented from PArgList.

virtual PString PConfigArgs::GetOptionString | ( | const PString & | optionName,
|  | const char * | dflt = `NULL` |
| ) |  |  | const`[virtual]`

Get option string.

Parameters:

  optionName | String code for the option
  dflt | Default value of the option string

Reimplemented from PArgList.

virtual PString PConfigArgs::GetOptionString | ( | const char * | optionStr,
|  | const char * | dflt = `NULL` |
| ) |  |  | const`[virtual]`

Get option string.

Parameters:

  optionStr | String letter code for the option
  dflt | Default value of the option string

Reimplemented from PArgList.

virtual PString PConfigArgs::GetOptionString | ( | char | optionChar,
|  | const char * | dflt = `NULL` |
| ) |  |  | const`[virtual]`

Get option string.

Gets the string associated with an option e.g. -ofile or -o file would return the string "file". An option may have an associated string if it had a ':' character folowing it in the specification string passed to the Parse() function.

Returns:
  the options associated string.

Parameters:

  optionChar | Character letter code for the option
  dflt | Default value of the option string

Reimplemented from PArgList.

const PString& PConfigArgs::GetSectionName | ( |  | ) | const`[inline]`

Get the PConfig section name for options.

void PConfigArgs::Save | ( | const PString & | optionName | ) |

Save the current options to the PConfig.

This function will check to see if the option name is present and if so, save to the PConfig all of the arguments present in the currently parsed list. Note that the optionName for saving is not saved to the PConfig itself as this would cause the data to be saved always!

Parameters:

  optionName | Option name for saving.

void PConfigArgs::SetNegationPrefix | ( | const PString & | prefix | ) | `[inline]`

Set the prefix for option negation.

The default is "no-".

Parameters:

  prefix | New prefix string

void PConfigArgs::SetSectionName | ( | const PString & | section | ) | `[inline]`

Set the PConfig section name for options.

Parameters:

  section | New section name

## Member Data Documentation

PConfig PConfigArgs::config `[protected]`

PString PConfigArgs::negationPrefix `[protected]`

PString PConfigArgs::sectionName `[protected]`

The documentation for this class was generated from the following file:

- args.h